<?php
 
 
 

namespace PhpWA\Protocol\Proto;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;




class DisappearingMode extends \Google\Protobuf\Internal\Message
{
    


    protected $initiator = null;
    


    protected $trigger = null;
    


    protected $initiatorDeviceJid = null;
    


    protected $initiatedByMe = null;

    











    public function __construct($data = NULL) {
        \PhpWA\Protocol\Proto\Metadata\WAProto::initOnce();
        parent::__construct($data);
    }

    



    public function getInitiator()
    {
        return isset($this->initiator) ? $this->initiator : 0;
    }

    public function hasInitiator()
    {
        return isset($this->initiator);
    }

    public function clearInitiator()
    {
        unset($this->initiator);
    }

    




    public function setInitiator($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\DisappearingMode\Initiator::class);
        $this->initiator = $var;

        return $this;
    }

    



    public function getTrigger()
    {
        return isset($this->trigger) ? $this->trigger : 0;
    }

    public function hasTrigger()
    {
        return isset($this->trigger);
    }

    public function clearTrigger()
    {
        unset($this->trigger);
    }

    




    public function setTrigger($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\DisappearingMode\Trigger::class);
        $this->trigger = $var;

        return $this;
    }

    



    public function getInitiatorDeviceJid()
    {
        return isset($this->initiatorDeviceJid) ? $this->initiatorDeviceJid : '';
    }

    public function hasInitiatorDeviceJid()
    {
        return isset($this->initiatorDeviceJid);
    }

    public function clearInitiatorDeviceJid()
    {
        unset($this->initiatorDeviceJid);
    }

    




    public function setInitiatorDeviceJid($var)
    {
        GPBUtil::checkString($var, True);
        $this->initiatorDeviceJid = $var;

        return $this;
    }

    



    public function getInitiatedByMe()
    {
        return isset($this->initiatedByMe) ? $this->initiatedByMe : false;
    }

    public function hasInitiatedByMe()
    {
        return isset($this->initiatedByMe);
    }

    public function clearInitiatedByMe()
    {
        unset($this->initiatedByMe);
    }

    




    public function setInitiatedByMe($var)
    {
        GPBUtil::checkBool($var);
        $this->initiatedByMe = $var;

        return $this;
    }

}

